namespace Parsing.Schema.BuildingBlocks;

using Parsing.Tokenization;

class IntegerBlock : BuildingBlockBase
{

    public IntegerBlock()
    {
    }

    public override IToken ParseWord(InputProvider inputs)
    {
        return new IntegerToken(inputs.YieldWord());
    }

    public override bool CanParseWord(InputProvider inputs)
    {
        using (inputs.GetLookaheadContext())
        {
            int number = 0;
            var success = int.TryParse(inputs.YieldWord(), out number);
            return success;
        }
    }

    public override BlockType GetBlockType()
    {
        return BlockType.Integer;
    }
}